/* data.c 15.1 06/08/90 10:04:48 */

/*

	Copyright (c) 1986 	Chris Guthrie

Permission to use, copy, modify, and distribute this
software and its documentation for any purpose and without
fee is hereby granted, provided that the above copyright
notice appear in all copies and that both that copyright
notice and this permission notice appear in supporting
documentation.  No representations are made about the
suitability of this software for any purpose.  It is
provided "as is" without express or implied warranty.

*/

/* Major overhaul by Daryl Poe.
 *
 * Copyright (c) 1989 Daryl Poe
 *
 * Ported to X11 by Jim Andreas.
 * Tractors, treaties, and other features by Norm Gee.
 * Damage window and shield bitmaps by Tom LaStrange.
 *
 * The above comments apply to this version as well, and this
 * notice must also appear in any copies or follow-ons.
 */

#include <stdio.h>
#include <sys/param.h>
#include "defs.h"
#include "weapon.h"
#include "system.h"
#include "ship.h"
#include "stats.h"
#include "player.h"
#include "torp.h"
#include "status.h"
#include "planet.h"
#include "phaser.h"
#include "message.h"
#include "shmem.h"
#include "data.h"

MEMORY	*sharedMemory;
PLAYER	*players,*me;
TORP 	*torps;
STATUS	*status;
SHIP 	*myship;
STATS 	*mystats;
PLANET 	*planets;
PHASER 	*phasers;
MESSAGE *messages;
MCTL 	*mctl;
TEAM	*team;
WATCHER	*watchers;

FILE *logfile;

int	oldalert = PFGREEN;	/* Avoid changing more than we have to */
int remap[9] = { 0, 1, 2, -1, 3, -1, -1, -1, 4 };
int	messpend;
int	lastcount;
int	mdisplayed;
int	copilot = 0;
int	nopilot = 1;
int	watch = 0;
int	selfdest;
int	udcounter;
int	lastm;
int	delay;
int	warncount = 0;
int	warntimer = -1;
int	mustexit = 0;
int semid;

long	start_time;

int	debug = 0;

double	oldmax = 0.0;

char *progname;  /* the name of the program running */

char Dtrek_dir[MAXPATHLEN];		/* dtrek main directory			*/
char Plfile[MAXPATHLEN];		/* planet file path 			*/
char Scoredir[MAXPATHLEN];		/* score directory path 		*/
char Motd[MAXPATHLEN];			/* message-of-the-day file path	*/
char Daemon[MAXPATHLEN];		/* daemon executable path 		*/	
char Robot[MAXPATHLEN];			/* robot executable path 		*/
char Shipmenu[MAXPATHLEN];		/* shipmenu executable path 	*/
char Bitmaps[MAXPATHLEN];		/* bitmap storage directory 	*/
char Logfilename[MAXPATHLEN];	/* logfile file path 			*/
char Dlogfilename[MAXPATHLEN];	/* daemon logfile file path 	*/
char Rlogfilename[MAXPATHLEN];	/* robot logfile file path	 	*/
char Shiparchives[MAXPATHLEN];	/* shiparchives directory      	*/
char Scores[MAXPATHLEN];		/* scores executable path      	*/
char Modefile[MAXPATHLEN];		/* game mode file path			*/
char Control_file[MAXPATHLEN];	/* game control file path		*/

char teamlet[] = {
	'I', 'F', 'R', 'K', 'O'
};
char *teamshort[] = {
	"IND", "FED", "ROM", "KLI", "ORI"
};

