/* torp.h 15.1 06/08/90 10:07:52 */

/*

	Copyright (c) 1986 	Chris Guthrie

Permission to use, copy, modify, and distribute this
software and its documentation for any purpose and without
fee is hereby granted, provided that the above copyright
notice appear in all copies and that both that copyright
notice and this permission notice appear in supporting
documentation.  No representations are made about the
suitability of this software for any purpose.  It is
provided "as is" without express or implied warranty.

*/

/* Major overhaul by Daryl Poe.
 *
 * Copyright (c) 1989 Daryl Poe
 *
 * Ported to X11 by Jim Andreas.
 * Tractors, treaties, and other features by Norm Gee.
 * Damage window and shield bitmaps by Tom LaStrange.
 *
 * The above comments apply to this version as well, and this
 * notice must also appear in any copies or follow-ons.
 */

/* values of t_status */
#define TFREE 		0
#define TMOVE 		1
#define TEXPLODE 	2
#define TOFF 		3
#define TSTRAIGHT 	4
#define TTRACK 		5
#define TRANDOM		6	/* for Probability Vortices */

typedef struct {
    int t_no;			/* Torpedo number */
    int t_status;		/* State information */
    int t_owner_no;		/* firer player # */
    int t_x,			/* current position */
        t_y;
    int t_dx,			/* current delta position */
        t_dy;
    unsigned char t_dir;	/* direction */
    int t_damage;		/* damage for direct hit */
    int t_speed;		/* Moving speed */
    int t_fuse;			/* Life left in current state */
	int t_arm;			/* Time until the torpedo arms itself */
    char t_war_mask;	/* enemies */
    char t_team_mask;	/* launching team */
	int t_decay;		/* reduce t_damage by this amount per turn */
	int t_target;		/* target player #, for tracking */
	short t_class;		/* WPN_PHOTON, WPN_MISSILE, etc. */
	int t_closest_planet;  /* current closest planet */
	int t_closest_planet_dist;  /* its distance */
} TORP;

