      SUBROUTINE WRITCH (ADD, BUFF, COUNT, TERM, *, *)
C
C     ROUTINE TO WRITE CHARACTERS.
C
C     ADD   - FCB ADDRESS.
C     BUFF  - BUFFER (WORD ADDRESS).
C     COUNT - TRANSFER COUNT.
C     TERM  - TERMINAL TYPE CODE:      0 - SET BY TERMDEF.
C                                      1 - HAZELTINE H1500.
C                                      2 - ADM-3A.
C                                      3 - ADDS (REGENT SERIES).
C                                      4 - TELEVIDEO 914.
C                                      5 - PERKIN ELMER 550.
C                                      6 - DEC VT 100.
C     *     - I/O ERROR RETURN ADDRESS.
C     *     - END-OF-FILE/END-OF-MEDIUM ERROR RETURN ADDRESS.
C
C     NWBUFF1 AND TDF2 USED ONLY ON GOULD-MPX SYSTEMS.
C     *** WATCH OUT AT THE 'EQUIVALENCE' STATEMENT !!! ***
C
C     INTEGER*1 NWBUFF1(80)
C
C     INTEGER*2 TDF2(0:11)
C
      INTEGER*4 ADD, BUFF(20), COUNT, TERM, NWBUFF(20), NWCOUNT,
     1 TDF4(0:5), IRIN(0:7), IROUT(0:7), TDFBUFF(20)
      CHARACTER ZNWBUFF*80
C
      LOGICAL LEXIST, INQDONE, CURRADDR
C     *** GOULD ONLY ***
C     EQUIVALENCE (TDF2(0),TDF4(0)), (NWBUFF1(1),NWBUFF(1),ZNWBUFF)
C     ALL OTHER SYSTEMS USE THE FOLLOWING:
      EQUIVALENCE (NWBUFF(1),ZNWBUFF)
C
      DATA INQDONE/.FALSE./, CURRADDR/.FALSE./
C
C
C     write (0,*) 'In WRITCH, count = ', count, ', term = ', term
      IF (COUNT .EQ. 0) RETURN
C
C     CHECK FOR TERMDEF TERMINAL DEFINITION.
C
      IF (TERM .NE. 0) GO TO 200
C     IF (CURRADDR) GO TO 120
C     IF (COUNT .NE. -1) THEN
C        CURRADDR = .FALSE.
C        GO TO 300
C     END IF
C     IF (.NOT. INQDONE) INQUIRE (FILE='@SYSTEM(SYSTEM)TERMPART',
C    1 EXIST=LEXIST)
C     IF (.NOT. LEXIST) THEN
C        WRITE (0,110)
C 110    FORMAT (/' *** MPX TERMINAL DEFINITIONS DO NOT EXIST -',
C    1    '     SEE YOUR SYSTEM ADMINISTRATOR FOR HELP.'/)
C        STOP
C     END IF
C     INQDONE = .TRUE.
C     CURRADDR = .TRUE.
C     RETURN
C
C     GET CURSOR ADDRESS STRING FROM TERMDEF SERVICE.
C     PREPARE TERMDEF BLOCK - GET (X,Y) CURSOR POSITION FROM BUFF.
C
C 120 TDF4 = 0
C     TDF4(0) = ' UT '
C     TDF4(1) = ADDR(TDFBUFF)
C     TDF2(4) = 'cm'
C     TDF2(6) = 40
C     NWBUFF(1) = BUFF(1)
C     TDF4(4) = NWBUFF1(1)
C     TDF4(5) = NWBUFF1(2)
C     IRIN(1) = ADDR(TDF4)
C     TDFBUFF = 0
C
C     CALL SYSTEM SERVICE TO GET CURSOR MOVEMENT SEQUENCE.
C
C     CALL MPXSVC (X'207A', IRIN, IROUT, ICC, ISTAT)
C     IF (ISTAT .NE. 0) THEN
C        WRITE (0,130) ISTAT
C 130    FORMAT (/' *** MPXSVC RETURNED WITH ISTAT =',I10/
C    1    '     SEE YOUR SYSTEM ADMINISTRATOR RE TERMDEF.'/)
C        STOP
C     END IF
C     IF (TDF2(7) .EQ. 0) THEN
C     UNKNOWN TERMINAL TYPE ERROR.
C        IF (TDF2(4) .EQ. 2) THEN
C           WRITE (0,140)
C 140       FORMAT (/' *** TERMDEF REPORTS AN UNKNOWN TERMINAL TYPE -'/
C    1       '     SEE YOUR SYSTEM ADMINISTRATOR FOR HELP.'/)
C           STOP
C     UNDEFINED FUNCTION FOR THIS TERMINAL - SKIP IT.
C        ELSE IF (TDF2(4) .EQ. 10) THEN
C           WRITE (0,150)
C 150       FORMAT (/' *** TERMDEF ERROR: ',
C    1       ' CURSOR MOVEMENT FUNCTION ''cm'' NOT DEFINED'/
C    2       '     SEE YOUR SYSTEM ADMINISTRATOR RE TERMDEF.'/)
C     ALL OTHER PROBLEMS.
C        ELSE
C           WRITE (0,160) TDF2(4)
C 160       FORMAT (/' *** TERMDEF ERROR NUMBER: ',I5,
C    1       ', FOR CURSOR MOVEMENT FUNCTION'/
C    2       '     SEE YOUR SYSTEM ADMINISTRATOR RE TERMDEF.'/)
C           STOP
C        END IF
C     END IF
C     DO 170 J=1,10
C 170 NWBUFF(J) = TDFBUFF(J)
C     NWCOUNT = TDF2(7)
C     CURRADDR = .FALSE.
C     GO TO 300
C
C     Copy incoming buffer to a local buffer for output.
C
  200 j = (count+3) / 4
      do 205 i=1,j
  205 nwbuff(i) = buff(i)
      nwcount = count
C     write (0,*) '           count = ', count, ', nwcount = ', nwcount
C     write (0,9999) (buff(i),i=1,j)
C9999 format ('            buff:'/(15x,5z9.8/))
C     write (0,9998) (nwbuff1(i),i=1,nwcount)
C9998 format ('            nwbuff1:'/(15x,10z3.2/))
C
C     CHECK FOR HAZELTINE TERMINAL.
C
      IF (TERM .NE. 1) GO TO 220
      IF (COUNT .NE. 2) THEN
         CURRADDR = .FALSE.
         GO TO 300
      END IF
      CALL HAZCONV (NWBUFF, NWCOUNT, CURRADDR)
      GO TO 300
C
C     CHECK FOR ADM TERMINAL.
C
  220 IF (TERM .NE. 2) GO TO 230
      IF (COUNT .NE. 2) THEN
         CURRADDR = .FALSE.
         GO TO 300
      END IF
      CALL ADMCONV (NWBUFF, NWCOUNT, CURRADDR)
      GO TO 300
C
C     CHECK FOR ADDS TERMINAL.
C
  230 IF (TERM .NE. 3) GO TO 240
      IF (COUNT .NE. 2) THEN
         CURRADDR = .FALSE.
         GO TO 300
      END IF
      CALL ADDCONV (NWBUFF, NWCOUNT, CURRADDR)
      GO TO 300
C
C     CHECK FOR TELEVIDEO TERMINAL.
C
  240 IF (TERM .NE. 4) GO TO 250
      IF (COUNT .NE. 2) THEN
         CURRADDR = .FALSE.
         GO TO 300
      END IF
      CALL TVICONV (NWBUFF, NWCOUNT, CURRADDR)
      GO TO 300
C
C     CHECK FOR PE 550 TERMINAL.
C
  250 IF (TERM .NE. 5) GO TO 260
      IF (COUNT .NE. 2) THEN
         CURRADDR = .FALSE.
         GO TO 300
      END IF
      CALL PECONV (NWBUFF, NWCOUNT, CURRADDR)
      GO TO 300
C
C     CHECK FOR VT 100 TERMINAL.
C
  260 IF (TERM .NE. 6) GO TO 300
      IF (COUNT .NE. 2) THEN
         CURRADDR = .FALSE.
         GO TO 300
      END IF
      CALL VTCONV (NWBUFF, NWCOUNT, CURRADDR)
C
C     Output new buffer using the new transfer count.
C
  300 if (nwcount .le. 0) return
      write (6,320,err=900) znwbuff(1:nwcount)
  320 format (a,$)
      call flush (6)
      RETURN
C
C     Error return.
C
  900 return 1
      END
