      PROGRAM ZOMBIES
C
C     DATA DESCRIPTION IS AS FOLLOWS
C     ==============================
C     B     -    BOARD POSITION TYPE INDICATOR
C                  1 = NOTHING THERE
C                  2 = OCCUPIED BY A ZOMBIE
C                  3 = OCCUPIED BY THE PLAYER
C                 >4 = INDEX INTO HOLE CAPACITY TABLE
C     Z     -    CO-ORDINATES OF EACH ZOMBIE
C     HOLES -    CAPACITY (IN ZOMBIES) OF EACH HOLE
C     CURSOR-    CURSOR CONTROL CODES FOR THE TERMINAL
C     P & Q -    MOVE DIRECTION VECTORS
C     RAND  -    RANDOM NUMBER
C     DISP  -    DISPLAY BUFFER
C     MESS  -    MESSAGE DISPLAY BUFFER
C
C     THE BASIC CURSOR CONTROL CO-ORDINATES ARE THOSE SUITABLE FOR
C     A HAZELTINE TERMINAL. I.E. X-Y ORDER WHERE X IS THE COLUMN NUMBER
C     FROM 0 TO 79 AND Y IS THE ROW NUMBER FROM 0 TO 23.
C     TOP LEFT IS 0,0           TOP RIGHT IS 79,0
C     BOTTOM LEFT IS 0,23       BOTTOM RIGHT IS 79,23
C
C        0,0-----------> X
C          |
C          |
C          |
C          |
C          V
C          Y
C
C     WORK AREA DECLARATIONS
C
      IMPLICIT INTEGER*4 (A-Z)
C
      PARAMETER (MAXPASS=50)
C
      INTEGER*4 B(20,35),Z(30,2)
      INTEGER*4 HOLES(25)
      INTEGER*4 CURSOR(10,22),BELL(10),CRET(10),LINF(10),CLRSCR(10),
     1 CURADD(10),HOME(10),CLRLIN(10),LCURSOR(22)
      INTEGER*4 DISPWORD,MESSWORD
      INTEGER*4 P(9),Q(9),TERM
      REAL*4 RAND
      character ans*1, zerror*80
C
C     STATEMENTS COMMENTED IN COLUMN 1 WITH 'CX' ARE FOR DEBUGGING THE
C     RANDOM NUMBER GENERATOR, WHICH USED TO HANG THE GAME.
C
CX    REAL*4 RANDSAVE(2,MAXPASS)
C
      EQUIVALENCE (HOME(1),CURSOR(1,1)), (LHOME,LCURSOR(1))
      EQUIVALENCE (CURADD(1),CURSOR(1,6)), (LCURADD,LCURSOR(6))
      EQUIVALENCE (CLRSCR(1),CURSOR(1,8)), (LCLRSCR,LCURSOR(8))
      EQUIVALENCE (CLRLIN(1),CURSOR(1,10)), (LCLRLIN,LCURSOR(10))
      EQUIVALENCE (BELL(1),CURSOR(1,19)), (LBELL,LCURSOR(19))
      EQUIVALENCE (CRET(1),CURSOR(1,21)), (LCRET,LCURSOR(21))
      EQUIVALENCE (LINF(1),CURSOR(1,22)), (LLINF,LCURSOR(22))
C
C     MESSAGES AND GENERAL DISPLAY AREA
C
      INTEGER ISLAND(18), SPACES(18), YORMOV(3)
      INTEGER MESSG1(10), MESSG2(10), MESSG3(18), MESSG4( 6)
      INTEGER MESSG5(18), MESSG6( 5), MESSG7( 8), MESSG8(13)
      INTEGER MESSG9( 4)
C
      CHARACTER ZISLAND*72, ZSPACES*72, ZYORMOV*12
      CHARACTER ZMESSG1*40, ZMESSG2*40, ZMESSG3*72, ZMESSG4*24
      CHARACTER ZMESSG5*72, ZMESSG6*20, ZMESSG7*32, ZMESSG8*52
      CHARACTER ZMESSG9*16
C
      EQUIVALENCE (ZISLAND,ISLAND(1)), (ZSPACES,SPACES(1))
      EQUIVALENCE (ZYORMOV,YORMOV(1)), (ZMESSG1,MESSG1(1))
      EQUIVALENCE (ZMESSG2,MESSG2(1)), (ZMESSG3,MESSG3(1))
      EQUIVALENCE (ZMESSG4,MESSG4(1)), (ZMESSG5,MESSG5(1))
      EQUIVALENCE (ZMESSG6,MESSG6(1)), (ZMESSG7,MESSG7(1))
      EQUIVALENCE (ZMESSG8,MESSG8(1)), (ZMESSG9,MESSG9(1))
C
      CHARACTER TEXT*10
C
C     Message initialization.
C
      DATA ZISLAND/'++++++++++++++++++++++++++++++++++++++++++++++++++++
     1++++++++++++++++++++'/
      DATA ZSPACES/' '/
      DATA ZYORMOV/'Your move ?'/
      DATA ZMESSG1/'Stay on the island, you can''t swim away'/
      DATA ZMESSG2/'Straight into the zombie''s mouth .....'/
      DATA ZMESSG3/'Luckily for you that pit is full of zombies, enablin
     1g you to cross it'/
      DATA ZMESSG4/'Head first into the pit'/
      DATA ZMESSG5/'Ha ha, a pit is now full of zombies, enabling other 
     1zombies to cross it'/
      DATA ZMESSG6/'Splash goes a zombie'/
      DATA ZMESSG7/'You''re zapped by a zombie ....'/
      DATA ZMESSG8/'Well done smart arse ---- the zombies are extinct'/
      DATA ZMESSG9/'Another game ?'/
C
C     OTHER INITIALIZATION
C
      DATA P/-1,0,1,-1,0,1,-1, 0, 1/
      DATA Q/ 1,1,1, 0,0,0,-1,-1,-1/
      DATA MAXZ/30/, MAXH/25/
C     DATA LFCUT/'UT  '/, LFCVDU/'VDU '/
C
C     OPEN VDU AND ADJUST ITS FCB
C
C     OPEN (UNIT=LFCUT, OPENMODE='U')
C     OPEN (UNIT=LFCVDU, OPENMODE='U')
C     JADD = M:GETFCB(LFCVDU)
C     CALL SETFCB (JADD)
C
C     CHECK FOR TERMINAL TYPE ON INPUT LINE.
C
C     CALL X:TSCAN (1, I, DISP, TEXT)
      TERM = -1
C     IF (I.NE.1 .OR. DISP(2).NE.2) GO TO 20
C     IF (TEXT(1:1) .EQ. '*') THEN
C        TERM = 0
C     ELSE IF (TEXT(1:1).GE.'1' .AND. TEXT(1:1).LE.'6') THEN
C        READ (TEXT(1:1),10) TERM
C  10    FORMAT (I1)
C     END IF
C     GO TO 50
C
   20 call putline (0, ' ')
      call putline (0,
     1 'You have just landed on the infamous Zombie Island.')
      call putline (0, ' ')
      call putline (0,
     1 'Your only hope of survival is to lure all the'//
     2 ' zombies into the pits')
      call putline (0,
     2 'on the island. Fortunately '//
     3 'for you the zombies can only move orthogonally.')
      call putline (0,
     4 'Unfortunately for you some of the pits only hold '//
     5 'a finite number of zombies.')
      call putline (0,
     6 'This game makes use of the cursor '//
     7 'control features on the terminals listed below')
      call putline (0,
     7 'and may not display the island and messages correctly '//
     8 'on another terminal type.')
      call putline (0, ' ')
      call putline (0,
     9 'The directions you may move in are '//
     A 'given by the following map, this map')
      call putline (0,
     A 'corresponds to the '//
     B 'numeric keypad on certain terminals with your'//
     C ' position')
      call putline (0,
     C 'corresponding to the 5 key:')
      call putline (0,
     C '          7 8 9')
      call putline (0,
     C '          4 Y 6')
      call putline (0,
     C '          1 2 3')
C
   50 CALL TERMSET (TERM, JADD, CURSOR, LCURSOR)
C     write (zerror,*) 'Got back from TERMSET'
C     call putline (0, zerror)
C
C     INITIALIZE DATA AREA
C
      RAND=0.0
      CALL RANDOM (RAND)
 240  DO 270 N1=1,MAXZ
      DO 270 N2=1,2
  270 Z(N1,N2)=0
      DO 280 N1=1,20
      DO 280 N2=1,35
  280 B(N1,N2)=1
C
C     GENERATE PLAYER'S POSITION.
C     BLOCK OUT A 3 BY 3 SQUARE CENTERED AT (X,Y).
C
      CALL RANDOM (RAND)
      X=IFIX(2.0+32.0*RAND)
      CALL RANDOM (RAND)
      Y=IFIX(2.0+17.0*RAND)
      DO 300 N1=Y-1,Y+1
      DO 300 N2=X-1,X+1
  300 B(N1,N2)=3
C
C     GENERATE ZOMBIES
C
      CALL RANDOM (RAND)
      Z1=IFIX(25.0*RAND)+5
      IF (Z1 .GT. MAXZ) Z1 = MAXZ
      DO 500 Z2=1,Z1
      IPASS = 0
 400  IPASS = IPASS + 1
      CALL RANDOM (RAND)
CX    RANDSAVE(1,IPASS) = RAND
      N1=IFIX(1.0+19.0*RAND)
      CALL RANDOM (RAND)
CX    RANDSAVE(2,IPASS) = RAND
      N2=IFIX(1.0+34.0*RAND)
      IF (B(N1,N2) .NE. 1) THEN
         IF (IPASS .LE. MAXPASS) GO TO 400
         WRITE (zerror,410) IPASS, Z2, Z1
 410     FORMAT (/' *** CAN NOT PLACE THE ZOMBIES IN',I4,
     1    ' PASSES FOR ZOMBIE',I3,' OF',I3/)
	 call putline (0, ' ')
	 call putline (0, zerror)
	 call putline (0, ' ')
CX       DO 420 I=1,IPASS
CX       WRITE (zerror,430) RANDSAVE(1,I), RANDSAVE(2,I)
CX420    call putline (0, zerror)
CX430    FORMAT (1X,2F15.6)
         GO TO 1600
      END IF
      Z(Z2,1)=N1
      Z(Z2,2)=N2
      B(N1,N2)=2
 500  CONTINUE
C
C     GENERATE POTHOLES
C
      CALL RANDOM (RAND)
      POTS=IFIX(1.0+0.6*Z1*RAND)
      IF (POTS .GT. Z1) POTS=Z1
      IF (POTS .GT. MAXH) POTS = MAXH
      A = 0
      DO 520 Z2=1,POTS
      IPASS = 0
 510  IPASS = IPASS + 1
      CALL RANDOM (RAND)
CX    RANDSAVE(1,IPASS) = RAND
      N1=IFIX(1.0+14.0*RAND)
      CALL RANDOM (RAND)
CX    RANDSAVE(2,IPASS) = RAND
      N2=IFIX(1.0+21.0*RAND)
      IF (B(N1,N2) .NE. 1) THEN
         IF (IPASS .LE. MAXPASS) GO TO 510
         WRITE (zerror,515) IPASS, Z2, POTS
 515     FORMAT (/' *** CAN NOT PLACE THE POTHOLES IN',I4,
     1    ' PASSES FOR POTHOLE',I3,' OF',I3/)
	 call putline (0, ' ')
	 call putline (0, zerror)
	 call putline (0, ' ')
CX       DO 516 I=1,IPASS
CX       WRITE (zerror,430) RANDSAVE(1,I), RANDSAVE(2,I)
CX516    call putline (0,zerror)
         GO TO 1600
      END IF
      B(N1,N2)=3+Z2
      HOLES(Z2)=30
      CALL RANDOM (RAND)
      IF (RAND .GT. 0.25) HOLES(Z2)=IFIX(2.0+4.0*RAND)
 520  A = A + HOLES(Z2)
C
C     ENSURE THE POTHOLES WILL HOLD ALL THE ZOMBIES.
C
      IF (A .LT. Z1) THEN
         CALL RANDOM (RAND)
         Z2 = IFIX(1.0+POTS*RAND)
         IF (Z2 .GT. POTS) Z2 = POTS
         HOLES(Z2) = HOLES(Z2) + Z1 - A + 1
      END IF
C
C     CLEAR 3 BY 3 SQUARE SURROUNDING PLAYER'S POSITION.
C
      DO 610 N1=Y-1,Y+1
      DO 610 N2=X-1,X+1
  610 B(N1,N2)=1
      B(Y,X)=3
C
C     DISPLAY THE ISLAND
C
      CALL WRITCH (JADD,HOME,LHOME,TERM,*1700,*1700)
      CALL WRITCH (JADD,CLRSCR,LCLRSCR,TERM,*1700,*1700)
      CALL WRITCH (JADD,ISLAND,72,TERM,*1700,*1700)
      DO 1000 N1=1,20
      CALL WRITCH (JADD,CRET,LCRET,TERM,*1700,*1700)
      CALL WRITCH (JADD,LINF,LLINF,TERM,*1700,*1700)
      CALL WRITCH (JADD,ISLAND,1,TERM,*1700,*1700)
      CALL ISETBUFFER1 (1, 71, MESSWORD)
      CALL ISETBUFFER1 (2, N1, MESSWORD)
      CALL TRANSP (MESSWORD, TERM)
      CALL WRITCH (JADD,CURADD,LCURADD,TERM,*1700,*1700)
      CALL WRITCH (JADD,MESSWORD,LCURADD,TERM,*1700,*1700)
      CALL WRITCH (JADD,ISLAND,1,TERM,*1700,*1700)
 1000 CONTINUE
      CALL WRITCH (JADD,CRET,LCRET,TERM,*1700,*1700)
      CALL WRITCH (JADD,LINF,LLINF,TERM,*1700,*1700)
      CALL WRITCH (JADD,ISLAND,72,TERM,*1700,*1700)
C
C     DISPLAY THE INHABITANTS
C
      DISPWORD = 0
      MESSWORD = 0
      DO 1030 N2=1,35
      DO 1020 N1=1,20
      IF (B(N1,N2) .EQ. 1) GO TO 1020
      IF (B(N1,N2) .EQ. 2) CALL ISETBUFFER1 (1, ICHAR('Z'), DISPWORD)
      IF (B(N1,N2) .EQ. 3) CALL ISETBUFFER1 (1, ICHAR('Y'), DISPWORD)
      IF (B(N1,N2) .GE. 4) CALL ISETBUFFER1 (1, ICHAR('O'), DISPWORD)
      CALL ISETBUFFER1 (1, N2*2, MESSWORD)
      CALL ISETBUFFER1 (2, N1, MESSWORD)
      CALL TRANSP (MESSWORD, TERM)
      CALL WRITCH (JADD,CURADD,LCURADD,TERM,*1700,*1700)
      CALL WRITCH (JADD,MESSWORD,LCURADD,TERM,*1700,*1700)
      CALL WRITCH (JADD,DISPWORD,1,TERM,*1700,*1700)
 1020 CONTINUE
 1030 CONTINUE
C
C     GET HIS MOVE
C
 1090 CALL ISETBUFFER1 (1, 0, MESSWORD)
      CALL ISETBUFFER1 (2, 23, MESSWORD)
      CALL TRANSP (MESSWORD, TERM)
      CALL WRITCH (JADD,CURADD,LCURADD,TERM,*1700,*1700)
      CALL WRITCH (JADD,MESSWORD,LCURADD,TERM,*1700,*1700)
      CALL WRITCH (JADD,YORMOV,12,TERM,*1700,*1700)
      CALL READCH (JADD,A,ANS,*1100,*1700)
      GO TO 1110
 1100 A = 5
 1110 CALL ISETBUFFER1 (1, 0, MESSWORD)
      CALL ISETBUFFER1 (2, 22, MESSWORD)
      CALL TRANSP (MESSWORD, TERM)
      CALL WRITCH (JADD,CURADD,LCURADD,TERM,*1700,*1700)
      CALL WRITCH (JADD,MESSWORD,LCURADD,TERM,*1700,*1700)
      IF (LCLRLIN .NE. 0) THEN
         CALL WRITCH (JADD,CLRLIN,LCLRLIN,TERM,*1700,*1700)
      ELSE
         CALL WRITCH (JADD,SPACES,72,TERM,*1700,*1700)
      END IF
      IF (A.LE.0 .OR. A.GE.10) A=5
C
C     CHECK HIS MOVE
C
      YL=Y
      XL=X
      YT=Y+Q(A)
      XT=X+P(A)
      IF (YT.GT.0 .AND. YT.LT.21 .AND. XT.GT.0 .AND.
     1    XT.LT.36) GO TO 1180
C
C     STAY ON THE ISLAND !!!!!!!!!!!!!!
C
      CALL ISETBUFFER1 (1, 0, MESSWORD)
      CALL ISETBUFFER1 (2, 22, MESSWORD)
      CALL TRANSP (MESSWORD, TERM)
      CALL WRITCH (JADD,CURADD,LCURADD,TERM,*1700,*1700)
      CALL WRITCH (JADD,MESSWORD,LCURADD,TERM,*1700,*1700)
      CALL WRITCH (JADD,MESSG1,40,TERM,*1700,*1700)
      GO TO 1090
C
 1180 B(Y,X)=1
      Y=YT
      X=XT
      CALL ISETBUFFER1 (1, XL*2, DISPWORD)
      CALL ISETBUFFER1 (2, YL, DISPWORD)
      CALL TRANSP (DISPWORD, TERM)
      CALL WRITCH (JADD,CURADD,LCURADD,TERM,*1700,*1700)
      CALL WRITCH (JADD,DISPWORD,LCURADD,TERM,*1700,*1700)
      CALL ISETBUFFER1 (1, ICHAR(' '), DISPWORD)
      CALL WRITCH (JADD,DISPWORD,1,TERM,*1700,*1700)
      CALL ISETBUFFER1 (1, X*2, DISPWORD)
      CALL ISETBUFFER1 (2, Y, DISPWORD)
      CALL TRANSP (DISPWORD, TERM)
      CALL WRITCH (JADD,CURADD,LCURADD,TERM,*1700,*1700)
      CALL WRITCH (JADD,DISPWORD,LCURADD,TERM,*1700,*1700)
      IF (B(Y,X) .GT. 4) GO TO 1230
      GO TO (1200,1220,1290,1230),B(Y,X)
C
C     MOVE IS OKAY
C
 1200 B(Y,X)=3
      CALL ISETBUFFER1 (1, ICHAR('Y'), DISPWORD)
      CALL WRITCH (JADD,DISPWORD,1,TERM,*1700,*1700)
      GO TO 1290
C
C     EATEN BY A ZOMBIE,    HOPE HE ENJOYED IT
C
 1220 CALL ISETBUFFER1 (1, ICHAR('@'), DISPWORD)
      CALL WRITCH (JADD,DISPWORD,1,TERM,*1700,*1700)
      CALL ISETBUFFER1 (1, 0, MESSWORD)
      CALL ISETBUFFER1 (2, 22, MESSWORD)
      CALL TRANSP (MESSWORD, TERM)
      CALL WRITCH (JADD,CURADD,LCURADD,TERM,*1700,*1700)
      CALL WRITCH (JADD,MESSWORD,LCURADD,TERM,*1700,*1700)
      CALL WRITCH (JADD,BELL,LBELL,TERM,*1700,*1700)
      CALL WRITCH (JADD,MESSG2,38,TERM,*1700,*1700)
      GO TO 1600
C
C     STEPPED INTO A HOLE - SEE WHAT HAPPENED.
C
 1230 IF (HOLES(B(Y,X)-3) .GT. 0) GO TO 1240
C
C     LUCKY , THE HOLE IS FULL
C
      CALL ISETBUFFER1 (1, 0, MESSWORD)
      CALL ISETBUFFER1 (2, 22, MESSWORD)
      CALL TRANSP (MESSWORD, TERM)
      CALL WRITCH (JADD,CURADD,LCURADD,TERM,*1700,*1700)
      CALL WRITCH (JADD,MESSWORD,LCURADD,TERM,*1700,*1700)
      CALL WRITCH (JADD,BELL,LBELL,TERM,*1700,*1700)
      CALL WRITCH (JADD,MESSG3,70,TERM,*1700,*1700)
      CALL WRITCH (JADD,CURADD,LCURADD,TERM,*1700,*1700)
      CALL WRITCH (JADD,DISPWORD,LCURADD,TERM,*1700,*1700)
      GO TO 1200
C
C     ITS THE PITS           AAAYYYEEEEEEEEEEEEEEEEEEEEEEE....
C
 1240 CALL ISETBUFFER1 (1, ICHAR('@'), DISPWORD)
      CALL WRITCH (JADD,DISPWORD,1,TERM,*1700,*1700)
      CALL ISETBUFFER1 (1, 0, MESSWORD)
      CALL ISETBUFFER1 (2, 22, MESSWORD)
      CALL TRANSP (MESSWORD, TERM)
      CALL WRITCH (JADD,CURADD,LCURADD,TERM,*1700,*1700)
      CALL WRITCH (JADD,MESSWORD,LCURADD,TERM,*1700,*1700)
      CALL WRITCH (JADD,BELL,LBELL,TERM,*1700,*1700)
      CALL WRITCH (JADD,MESSG4,24,TERM,*1700,*1700)
      GO TO 1600
C
C     FOR EACH ZOMBIE CALCULATE HIS ORTHOGONAL MOVE
C     AND CHECK THE RESULT OF THE MOVE
C     DON'T TREAD ON ANOTHER ZOMBIE
C
 1290 Z2=1
 1300 Z8=Z(Z2,1)
      Z9=Z(Z2,2)
      B(Z8,Z9)=1
      Z8L=Z8
      Z9L=Z9
      YT=0
      IF (Y .EQ. Z8) GO TO 1310
      YT=ISIGN(1,Y-Z8)
 1310 XT=0
      IF (X .EQ. Z9) GO TO 1320
      XT=ISIGN(1,X-Z9)
 1320 IF (IABS(YT) .NE. IABS(XT)) GO TO 1330
      CALL RANDOM (RAND)
      IF (RAND .GT. 0.5) YT=0
      IF (RAND .LT. 0.5) XT=0
 1330 Z8=Z8+YT
      Z9=Z9+XT
      IF (Z8.LT.1 .OR. Z8.GT.20) GO TO 1450
      IF (Z9.LT.1 .OR. Z9.GT.35) GO TO 1450
      IF (B(Z8,Z9) .GT. 4) GO TO 1350
      GO TO (1480,1450,1430,1350),B(Z8,Z9)
C
C     A HOLE IS FULL
C
 1350 IF (HOLES(B(Z8,Z9)-3) .GT. 0) GO TO 1360
      CALL ISETBUFFER1 (1, 0, MESSWORD)
      CALL ISETBUFFER1 (2, 22, MESSWORD)
      CALL TRANSP (MESSWORD, TERM)
      CALL WRITCH (JADD,CURADD,LCURADD,TERM,*1700,*1700)
      CALL WRITCH (JADD,MESSWORD,LCURADD,TERM,*1700,*1700)
      CALL WRITCH (JADD,MESSG5,72,TERM,*1700,*1700)
      GO TO 1480
C
C     ITS THE PITS
C
 1360 CALL ISETBUFFER1 (1, Z9L*2, DISPWORD)
      CALL ISETBUFFER1 (2, Z8L, DISPWORD)
      CALL TRANSP (DISPWORD, TERM)
      CALL WRITCH (JADD,CURADD,LCURADD,TERM,*1700,*1700)
      CALL WRITCH (JADD,DISPWORD,LCURADD,TERM,*1700,*1700)
      CALL ISETBUFFER1 (1, ICHAR(' '), DISPWORD)
      CALL WRITCH (JADD,DISPWORD,1,TERM,*1700,*1700)
      CALL ISETBUFFER1 (1, Z9*2, DISPWORD)
      CALL ISETBUFFER1 (2, Z8, DISPWORD)
      CALL TRANSP (DISPWORD, TERM)
      CALL WRITCH (JADD,CURADD,LCURADD,TERM,*1700,*1700)
      CALL WRITCH (JADD,DISPWORD,LCURADD,TERM,*1700,*1700)
      CALL ISETBUFFER1 (1, ICHAR('O'), DISPWORD)
      CALL WRITCH (JADD,DISPWORD,1,TERM,*1700,*1700)
      CALL ISETBUFFER1 (1, 0, MESSWORD)
      CALL ISETBUFFER1 (2, 22, MESSWORD)
      CALL TRANSP (MESSWORD, TERM)
      CALL WRITCH (JADD,CURADD,LCURADD,TERM,*1700,*1700)
      CALL WRITCH (JADD,MESSWORD,LCURADD,TERM,*1700,*1700)
      CALL WRITCH (JADD,BELL,LBELL,TERM,*1700,*1700)
      CALL WRITCH (JADD,MESSG6,20,TERM,*1700,*1700)
      HOLES(B(Z8,Z9)-3)=HOLES(B(Z8,Z9)-3)-1
      DO 1400 Z3=Z2,Z1
      Z(Z3,1)=Z(Z3+1,1)
      Z(Z3,2)=Z(Z3+1,2)
 1400 CONTINUE
      Z1=Z1-1
      GO TO 1520
C
C     GOT HIM    MUNCH MUNCH
C
 1430 CALL ISETBUFFER1 (1, Z9L*2, DISPWORD)
      CALL ISETBUFFER1 (2, Z8L, DISPWORD)
      CALL TRANSP (DISPWORD, TERM)
      CALL WRITCH (JADD,CURADD,LCURADD,TERM,*1700,*1700)
      CALL WRITCH (JADD,DISPWORD,LCURADD,TERM,*1700,*1700)
      CALL ISETBUFFER1 (1, ICHAR(' '), DISPWORD)
      CALL WRITCH (JADD,DISPWORD,1,TERM,*1700,*1700)
      CALL ISETBUFFER1 (1, Z9*2, DISPWORD)
      CALL ISETBUFFER1 (2, Z8, DISPWORD)
      CALL TRANSP (DISPWORD, TERM)
      CALL WRITCH (JADD,CURADD,LCURADD,TERM,*1700,*1700)
      CALL WRITCH (JADD,DISPWORD,LCURADD,TERM,*1700,*1700)
      CALL ISETBUFFER1 (1, ICHAR('@'), DISPWORD)
      CALL WRITCH (JADD,DISPWORD,1,TERM,*1700,*1700)
      CALL ISETBUFFER1 (1, 0, MESSWORD)
      CALL ISETBUFFER1 (2, 22, MESSWORD)
      CALL TRANSP (MESSWORD, TERM)
      CALL WRITCH (JADD,CURADD,LCURADD,TERM,*1700,*1700)
      CALL WRITCH (JADD,MESSWORD,LCURADD,TERM,*1700,*1700)
      CALL WRITCH (JADD,BELL,LBELL,TERM,*1700,*1700)
      CALL WRITCH (JADD,MESSG7,30,TERM,*1700,*1700)
      GO TO 1600
 1450 B(Z8L,Z9L)=2
      GO TO 1510
C
C     VALID MOVE  BUT  HAS NO EFFECT
C
 1480 B(Z8,Z9)=2
      Z(Z2,1)=Z8
      Z(Z2,2)=Z9
      CALL ISETBUFFER1 (1, Z9L*2, DISPWORD)
      CALL ISETBUFFER1 (2, Z8L, DISPWORD)
      CALL TRANSP (DISPWORD, TERM)
      CALL WRITCH (JADD,CURADD,LCURADD,TERM,*1700,*1700)
      CALL WRITCH (JADD,DISPWORD,LCURADD,TERM,*1700,*1700)
      CALL ISETBUFFER1 (1, ICHAR(' '), DISPWORD)
      CALL WRITCH (JADD,DISPWORD,1,TERM,*1700,*1700)
      CALL ISETBUFFER1 (1, Z9*2, DISPWORD)
      CALL ISETBUFFER1 (2, Z8, DISPWORD)
      CALL TRANSP (DISPWORD, TERM)
      CALL WRITCH (JADD,CURADD,LCURADD,TERM,*1700,*1700)
      CALL WRITCH (JADD,DISPWORD,LCURADD,TERM,*1700,*1700)
      CALL ISETBUFFER1 (1, ICHAR('Z'), DISPWORD)
      CALL WRITCH (JADD,DISPWORD,1,TERM,*1700,*1700)
C
C     ANY ZOMBIES LEFT ?
C
 1510 Z2=Z2+1
 1520 IF (Z2 .LE. Z1) GO TO 1300
      IF (Z1 .GE. 1) GO TO 1090
      CALL ISETBUFFER1 (1, 0, MESSWORD)
      CALL ISETBUFFER1 (2, 22, MESSWORD)
      CALL TRANSP (MESSWORD, TERM)
      CALL WRITCH (JADD,CURADD,LCURADD,TERM,*1700,*1700)
      CALL WRITCH (JADD,MESSWORD,LCURADD,TERM,*1700,*1700)
      CALL WRITCH (JADD,MESSG8,50,TERM,*1700,*1700)
 1600 CALL ISETBUFFER1 (1, 0, MESSWORD)
      CALL ISETBUFFER1 (2, 23, MESSWORD)
      CALL TRANSP (MESSWORD, TERM)
      CALL WRITCH (JADD,CURADD,LCURADD,TERM,*1700,*1700)
      CALL WRITCH (JADD,MESSWORD,LCURADD,TERM,*1700,*1700)
      CALL WRITCH (JADD,MESSG9,16,TERM,*1700,*1700)
      ans = ' '
      CALL READCH (JADD,A,ANS,*1700,*1700)
      IF (ANS.EQ.'Y' .OR. ANS.EQ.'y') GO TO 240
 1700 STOP
      END
